/*jshint node:true*/

module.exports = function(grunt) {

	grunt.initConfig({
		spec: {
			unit: {
				options: {
					specs: 'tests/unit/*.coffee',
					minijasminenode: {
						showColors: true
					}
				}
			},
			e2e: {
				options: {
					specs: 'tests/e2e/*.coffee',
					minijasminenode: {
						showColors: true
					}
				}
			}
		},

		concat: {
			styleguidecss: {
				files: [
					{'styleguide/css/styleguide.css': [
						'vendor/pure/bower_components/normalize-css/normalize.css',
						'vendor/pure/src/base/css/base.css',

						'styleguide/css/__grids-units.css',


						'vendor/pure/src/buttons/css/buttons-core.css',
						'vendor/pure/src/buttons/css/buttons.css',

						'vendor/pure/src/forms/css/forms.css',
						'vendor/pure/src/forms/css/forms-r.css',

						'vendor/pure/src/grids/css/grids-core.css',

						'vendor/pure/src/menus/css/menus-core.css',
						'vendor/pure/src/menus/css/menus-horizontal.css',
						'vendor/pure/src/menus/css/menus-dropdown.css',
						'vendor/pure/src/menus/css/menus-skin.css',

						'styleguide/src/css/*.css',

						'styleguide/css/__grids-responsive.css'

					]}
				]
			}
		},

		pure_grids: {
			default_units: {
				dest: 'styleguide/css/__grids-units.css',

				options: {
					units: [5, 24]
				}
			},

			responsive: {
				dest: 'styleguide/css/__grids-responsive.css',

				options: {
					mediaQueries: {
						sm: 'screen and (min-width: 35.5em)',   // 568px
						md: 'screen and (min-width: 48em)',     // 768px
						lg: 'screen and (min-width: 64em)',     // 1024px
						xl: 'screen and (min-width: 80em)'      // 1280px
					}
				}
			}
		},

		watch: {
			test: {
				files: [
					'**/*.js',
					'tests/**/*.coffee'
				],
				tasks: ['test']
			},

			unit: {
				files: [
					'**/*.js',
					'tests/**/*.coffee'
				],
				tasks: ['spec:unit']
			}
		}
	});

	grunt.loadNpmTasks('grunt-jasmine-bundle');
	grunt.loadNpmTasks('grunt-contrib-watch');
	grunt.loadNpmTasks('grunt-contrib-concat');
	grunt.loadNpmTasks('grunt-pure-grids');

	grunt.registerTask('test', ['spec:unit', 'spec:e2e']);
	//grunt.registerTask('watch:test');
	//
	grunt.registerTask('build:styleguide:css', [
		'pure_grids',
		'concat:styleguidecss'
	]);

};
