var _ = require('underscore');

var Base = require('./base.js');

function Pure_grids() {
	Base.call(this);
}

Pure_grids.prototype = Object.create(Base.prototype);
Pure_grids.prototype.constructor = Base;

Pure_grids.prototype.init = function(conf, outputPath) {
	this.gridConfig = conf;

	var mediaQueries = {};
	_.each(conf.breakpoints, function(unit, rule) {
		mediaQueries[rule] = 'screen and (min-width: ' + unit + 'em)';
	});

	this.config = {
		default_units: {
			dest: outputPath + '/__grids-units.css',

			options: {
				units: conf.units
			}
		},

		responsive: {
			dest: outputPath + '/__grids-responsive.css',

			options: {
				mediaQueries: mediaQueries
			}
		}
	};

};


Pure_grids.prototype.insertGridPaths = function(paths, outputPath) {

	var pathsToInsert = [
		outputPath + '/__grids-units.css',
		outputPath + '/__grids-responsive.css'
	];
	var index = null;

	if(this.gridConfig.pushpull){
		//console.log('yup', );
		///process.exit();
		pathsToInsert.push(outputPath+'/__purePushPull.css');
	}

	for (var i = 0; i < paths.length; i++) {
		if (paths[i] === '__grid__') {
			index = i;
			break;
		}
	}

	if (index !== null) {

		var left = paths.slice(0, index);
		paths = left.concat(pathsToInsert, paths.slice(index + 1));

	}

	return paths;

};


module.exports = Pure_grids;
