/*jshint node:true*/

module.exports = function (grunt) {
	'use strict';

	grunt.task.registerTask('pure_push_pull', 'Generate Push Pull CSS for PureCss', function() {

		var base, valueInt, values, valuesIE,
			config = grunt.config.data.pure_push_pull.main,
			units = config.options.units,
			breakpoints = config.options.breakpoints;


		base = 'div[class*="pure-pull"], div[class*="pure-push"]{\n\tposition: relative;\n}\n\n';

		Object.keys(breakpoints).forEach(function (key) {
			base += '@media screen and (min-width: '+config.options.breakpoints[key]+'em) {\n';
			for(var y=0 ; y < units.length; y +=1){
				var unit = units[y];
				for(var i=1; i<= unit; i +=1){
					valueInt = (100/unit) * i;
					values = valueInt.toFixed(4) + '%;\n';
					valuesIE = (valueInt - 0.031).toFixed(4) + '%;\n';

					if(valueInt === 100){
						continue;
					}

					base += addClass('push-' + key, i, values, valuesIE, 'left', unit);
					base += addClass('pull-' + key, i, values, valuesIE, 'right', unit);

				}
			}
			base += '}\n\n';

		});


		grunt.file.write( config.dest, base);
		grunt.log.writeln('File ' + config.dest + ' created.');

	});

	function addClass(width, index, val, valIE, side, unit){
		var string = '';
		if(index > 1 && (index /getGCD(index, unit)) !== index){
			if((index /getGCD(index, unit)) === (unit /getGCD(index, unit))){
				string += '\t.pure-'+width+'-'+ (index /getGCD(index, unit)) +',\n';
			}
			else {
				string += '\t.pure-'+width+'-'+ (index /getGCD(index, unit)) + '-' + (unit /getGCD(index, unit)) +',\n';
			}
		}
		if(index === unit){
			string += '\t.pure-'+width+'-'+index+ '{\n';
		}
		else {
			string += '\t.pure-'+width+'-'+index+'-'+unit+' {\n';
		}
		string += '\t\t'+side+': '+val;
		if(index !== unit){
			string += '\t\t*'+side+': '+valIE;
		}

		string += '\t}\n\n';
		return string;
	}

	function getGCD(a, b) {
		return b ? getGCD(b, a % b) : a;
	}

};