/*jshint node:true*/
module.exports = function (grunt) {
    'use strict';

    grunt.task.registerMultiTask('rework', 'Apply rework plugins', function() {

        var fs = require('fs');
        var rework = require('rework');
        var media = require('rework-custom-media');
        var vars = require('rework-vars');
        //var colors = require('rework-plugin-colors');
        var tally = 0;

        this.files.forEach(function (filePair) {

            filePair.src.forEach(function (file) {
                grunt.log.write('Processing ' + file+'...');

                // css to be processed
                var css = fs.readFileSync(file, 'utf8').toString();

                // process css using rework-custom-media
                try{
                    css = rework(css)
                        .use(media())
                        .use(vars({preserve:true}))
                        //.use(colors)
                        .toString();
                }catch(err){
                    console.log('');
                    console.log(err);
                    process.exit();
                }

                // write file
                grunt.file.write(file, css);

                grunt.log.ok();

                tally += 1;
            });


        });

        grunt.log.writeln('Reworked ' + String(tally).cyan + ' files.');

    });
};
