/*global Handlebars*/
Handlebars.registerHelper('each', function(context, options) {
	var ret = "",
		namedContext,
		odd = true;

	for(var i=0, j=context.length; i<j; i++) {
		namedContext = {};
		namedContext[options.hash.as] = context[i];

		if(options.hash.iteration){
			namedContext[options.hash.iteration] = {
				index: i,
				cycle: i+1,
				total: context.length,
				isFirst: i===0,
				isLast: i===context.length-1,
				isOdd: odd,
				isEven: !odd
			};
		}

		ret = ret + options.fn(namedContext);
		odd = !odd;
	}

	return ret;
});
/*global Handlebars*/
Handlebars.registerHelper('falimage', function(options){
	return new Handlebars.SafeString('<img src="placeholder/'+options.hash.width+'" class="'+options.hash.class+'">');
});
/*global Handlebars*/
Handlebars.registerHelper('?', function(condition, then, else_){
	return condition ? then : (else_ || '');
});
/*global Handlebars*/
Handlebars.registerHelper('if', function (conditional, operator, compareTo, options) {
	if (Handlebars.Utils.isFunction(conditional)) {
		conditional = conditional.call(this);
	}
	
	if(arguments.length === 2){
		options = operator;
	}

	if(typeof operator === 'string'){
		switch (operator) {
			case '==':
				return (conditional === compareTo) ? options.fn(this) : options.inverse(this);
			case '<':
				return (conditional < compareTo) ? options.fn(this) : options.inverse(this);
			case '<=':
				return (conditional <= compareTo) ? options.fn(this) : options.inverse(this);
			case '>':
				return (conditional > compareTo) ? options.fn(this) : options.inverse(this);
			case '>=':
				return (conditional >= compareTo) ? options.fn(this) : options.inverse(this);
			case '!=':
				return (conditional !== compareTo) ? options.fn(this) : options.inverse(this);
			default:
			return options.inverse(this);
		}
	}

	// Default behavior is to render the positive path if the value is truthy and not empty.
	// The `includeZero` option may be set to treat the condtional as purely not empty based on the
	// behavior of isEmpty. Effectively this determines if 0 is handled by the positive path or negative.
	if (!options.hash.includeZero && !conditional || Handlebars.Utils.isEmpty(conditional)) {
		return options.inverse(this);
	} else {
		return options.fn(this);
	}
});
/*global Handlebars,handlebarsLayouts*/
Handlebars.registerHelper(handlebarsLayouts(Handlebars));
/*global Handlebars*/

Handlebars.registerHelper('f:link:page', function(options){
	return '<a href="#id='+options.hash.pageUid+'" '+(options.hash['class'] ? 'class="'+options.hash['class']+'"' : '')+'>'+options.fn(this)+'</a>';
});
/*global Handlebars,_*/

//@TODO handle current page
function vPageMenu(options){
	console.log('vPageMenu',options);
	var _pages = window.SIFE.data._pages;


	// helper function
	function getSubpages(pageId){
		return _.findWhere(_pages, {"uid":parseInt(pageId,10)})._subpages;
	}



	var pages;
	if(options.hash.pages){
		pages = getSubpages.call(this, options.hash.pages);
	}else if(options.hash.pageUid){
		pages = getSubpages.call(this, options.hash.pageUid);
	}else{
		pages = _pages;
	}

	//set curent page as current
	_.each(pages, function(page){

		page.current = (page.uid == this._currentPageId);

	},this);

	//console.log('pages', pages);

	for (var i = 0; i < pages.length; i++) {
		if(pages[i]._subpages){
			pages[i].hasSubPages = true;
		}
	}

	return options.fn({menu:pages});
}
Handlebars.registerHelper('v:page:menu', vPageMenu);
Handlebars.registerHelper('v:page:menu:directory', vPageMenu);

Handlebars.registerHelper('v:page:languageMenu', function(options){
	var as = options.hash.as || 'languageMenu';
	var obj = {};
	obj[as] = this._languages;
	console.log('>', obj);
	return options.fn(obj);
});