process.env.NODE_ENV = 'test';

gruntHelper = require '../../lib/gruntHelper.js'


describe 'gruntHelper', ->
	Given -> @subject = gruntHelper

	Then -> typeof @subject == 'object'
	Then -> typeof @subject.runTasks == 'function'
	Then -> typeof @subject._private == 'object'
	Then -> typeof @subject._private.getFullConfig == 'function'

	beforeEach -> @subject.reset()

	describe 'getFullConfig', ->
		fullConfig = null;
		Given ->
			@subject.clean.add('foo', 'bar')
			@subject.concat.add('foo', 'bar', ['baz','baz2'])
		When -> fullConfig = @subject._private.getFullConfig()
		Then -> expect(fullConfig).toEqual({
			clean:{foo:['bar']},
			concat:{foo:files:[{bar:['baz','baz2']}]}
		})

	require './gruntHelpers/clean.coffee'
	require './gruntHelpers/concat.coffee'
	require './gruntHelpers/pure_grids.coffee'
	require './gruntHelpers/handlebars.coffee'

